module Gargantext.Components.NodeSelection.Types where

import Gargantext.Prelude

import Data.Eq.Generic (genericEq)
import Data.Generic.Rep (class Generic)
import Data.Maybe (Maybe(..))
import Gargantext.Types (ListId)
import Simple.JSON as JSON

data Selection = ChildNodes | SelectedNodes (Array ListId) 
derive instance Generic Selection _
instance Show Selection where
  show ChildNodes = "Child Nodes"
  show (SelectedNodes _) = "Selected Nodes"
instance Eq Selection where eq = genericEq
instance Read Selection where
  read "Child Nodes" = Just ChildNodes
  read "Selected Nodes" = Just $ SelectedNodes []
  read _ = Nothing
instance JSON.WriteForeign Selection where
  writeImpl ChildNodes = JSON.writeImpl { "type": "ChildNodes" }
  writeImpl (SelectedNodes ids) = JSON.writeImpl { "type": "SelectedNodes", value: ids }

selectedNodesIds :: Selection -> Array ListId
selectedNodesIds (SelectedNodes ids) = ids
selectedNodesIds _                   = []

